// Program setup.prg  (a cleaned up version of the program for public)
// January 19, 2007  
// This is a gauss program that does the main work of calculating sales, operating profit, and the distance stuff in a particular year
// given a particular configuration of Wal-Mart stores.  The main procedure is proc var_annual_calc(,) which is at the bottom of the program
//
// The inputs of the program are 
//       store_exist (a vector of indicator variables saying whether a given store location has a general merchandise store
//       super_exist (a vector of indicator variables says whether a given store location has a supercenter
//       year_evaluate (the year needed for wages, demographics)
//       x            (a vector of indicator variables specifying whether a store location has been there 2 or more years)
//
//       Note the there are 3176 stores. But they are numbered between 1 and 5498 because Wal-Mart skipped numbers.  It is convenient to have the row
//       of these indicator variables correspond to the number.  Therefore, we we use something called "fill format" where the indicator is 
//        from 1 to 5498 (for store_exist, super_exist, x) and if store_exist[i]=1 this means Wal-Mart store number i is open.  And the locations
//       store numbers not corresponding to a real store are just left at zero.
//
//  
//  The program takes as given a vector of parameters for the demand model.  this is set to the vector corresponding to the constrained model
//  in the paper. The are other various aspects of the operating profit in here.  Se the paper for where these parameters came from
//
//  


load blkgrp_dat_2000=d:\a_data\proj\wal_proj\public\dat\blkgrp_dat2000;
load store_neig_2000=d:\a_data\proj\wal_proj\public\dat\store_neig_2000;
load first_last_store_2000=d:\a_data\proj\wal_proj\public\dat\first_last_store_2000;
load first_last_blkgrp_sort_store2000=d:\a_data\proj\wal_proj\public\dat\first_last_blkgrp_sort_store2000; 
load store_neig2000_sort_store=d:\a_data\proj\wal_proj\public\dat\store_neig2000_sort_store; 

load blkgrp_dat_1990=d:\a_data\proj\wal_proj\public\dat\blkgrp_dat1990;
load store_neig_1990=d:\a_data\proj\wal_proj\public\dat\store_neig_1990;
load first_last_store_1990=d:\a_data\proj\wal_proj\public\dat\first_last_store_1990;
load first_last_blkgrp_sort_store1990=d:\a_data\proj\wal_proj\public\dat\first_last_blkgrp_sort_store1990; 
load store_neig1990_sort_store=d:\a_data\proj\wal_proj\public\dat\store_neig1990_sort_store; 

load blkgrp_dat_1980=d:\a_data\proj\wal_proj\public\dat\blkgrp_dat1980;
load store_neig_1980=d:\a_data\proj\wal_proj\public\dat\store_neig_1980;
load first_last_store_1980=d:\a_data\proj\wal_proj\public\dat\first_last_store_1980;
load first_last_blkgrp_sort_store1980=d:\a_data\proj\wal_proj\public\dat\first_last_blkgrp_sort_store1980; 
load store_neig1980_sort_store=d:\a_data\proj\wal_proj\public\dat\store_neig1980_sort_store; 

load RegDC_dat[43,5]=d:\a_data\proj\wal_proj\public\dat\RegDC_dat.asc;
load FoodDC_dat[35,5]=d:\a_data\proj\wal_proj\public\dat\FoodDC_dat.asc;
// from SAS: put RegDC_index ',' lat ',' long ',' date_open_continuous ',' year_open;
// from SAS:put FoodDC_index ',' lat ',' long ',' date_open_continuous ',' year_open;

load RegDC_distmat=d:\a_data\proj\wal_proj\public\dat\RegDC_dist_mat;
load FoodDC_distmat=d:\a_data\proj\wal_proj\public\dat\FoodDC_dist_mat;

load wage_store_year=d:\a_data\proj\wal_proj\public\dat\wage_store_year;
load rent_index_store_year=d:\a_data\proj\wal_proj\public\dat\rent_index_store_year;

Ibig_2000=rows(blkgrp_dat_2000);
n_2000     =blkgrp_dat_2000[.,2]./1000;
neig5_2000 =blkgrp_dat_2000[.,3]./1000;
neig10_2000=blkgrp_dat_2000[.,4]./1000;
neig15_2000=blkgrp_dat_2000[.,5]./1000;
pcihold_2000=.001.*blkgrp_dat_2000[.,8];
pcitrun_2000=pcihold_2000.*(pcihold_2000.>=5) + 5.*(pcihold_2000.<5);
blackshr_2000=blkgrp_dat_2000[.,9];
youngshr_2000=blkgrp_dat_2000[.,10];
oldshr_2000=blkgrp_dat_2000[.,11];
first_store_2000=first_last_store_2000[.,1];
last_store_2000=first_last_store_2000[.,2];
clear blkgrp_dat_2000, pcihold_2000, first_last_store_2000;

Ibig_1990=rows(blkgrp_dat_1990);
n_1990     =blkgrp_dat_1990[.,2]./1000;
neig5_1990 =blkgrp_dat_1990[.,3]./1000;
neig10_1990=blkgrp_dat_1990[.,4]./1000;
neig15_1990=blkgrp_dat_1990[.,5]./1000;
pcihold_1990=(172.2/130.7).*(.001).*blkgrp_dat_1990[.,8];  /* adjust for changes in cpi.  use annual average urban consumers */
pcitrun_1990=pcihold_1990.*(pcihold_1990.>=5) + 5.*(pcihold_1990.<5);
blackshr_1990=blkgrp_dat_1990[.,9];
youngshr_1990=blkgrp_dat_1990[.,10];
oldshr_1990=blkgrp_dat_1990[.,11];
first_store_1990=first_last_store_1990[.,1];
last_store_1990=first_last_store_1990[.,2];
clear blkgrp_dat_1990, pcihold_1990, first_last_store_1990;

Ibig_1980=rows(blkgrp_dat_1980);
n_1980     =blkgrp_dat_1980[.,2]./1000;
neig5_1980 =blkgrp_dat_1980[.,3]./1000;
neig10_1980=blkgrp_dat_1980[.,4]./1000;
neig15_1980=blkgrp_dat_1980[.,5]./1000;
pcihold_1980=(172.2/82.4).*(.001).*blkgrp_dat_1980[.,8];  /* adjust pci for cpi */
pcitrun_1980=pcihold_1980.*(pcihold_1980.>=5) + 5.*(pcihold_1980.<5);
blackshr_1980=blkgrp_dat_1980[.,9];
youngshr_1980=blkgrp_dat_1980[.,10];
oldshr_1980=blkgrp_dat_1980[.,11];
first_store_1980=first_last_store_1980[.,1];
last_store_1980=first_last_store_1980[.,2];
clear blkgrp_dat_1980, pcihold_1980, first_last_store_1980;


/*Step 2:  Store-level data */

// Next load in store information (year_open information for years going Feb 1-Jan31.)
load store_year_open=d:\a_data\proj\wal_proj\public\dat\store_year_open;
//  Note below there are only 3176 stores.  But convenient to fill things with missing values so storenum is rownum 
// store_year_open in fill format and has: storenum year_open year_super year_open_state year_super_state st2 ;
max_storenum=rows(store_year_open);
storenum=store_year_open[.,1];
year_open=store_year_open[.,2];
year_super=store_year_open[.,3];
year_open_state=store_year_open[.,4]; year_open_state=missrv(year_open_state,9999.*ones(max_storenum,1));  
year_super_state=store_year_open[.,5];year_super_state=missrv(year_super_state,9999.*ones(max_storenum,1));  
st2_fips=store_year_open[.,6];
actualstore=year_open.<9999;


year_RegDC=RegDC_dat[.,5];
year_FoodDC=FoodDC_dat[.,5];



// Note above is using two variables for same thing.  Later clean this up and just use one.


/* Next load in store neigpop info, have to convert to fill  */
load hold=d:\a_data\proj\wal_proj\public\dat\store_dat_neigpop;
store_dat_neigpop=storenum~actualstore~zeros(max_storenum,9);
store_dat_neigpop[selif(storenum,actualstore),3:11]=hold[.,2:10];

neig5_2000_store=store_dat_neigpop[.,3]./1000; 
neig5_1990_store=store_dat_neigpop[.,6]./1000;
neig5_1980_store=store_dat_neigpop[.,9]./1000;

/*Step 3: Inialize Demand Parameters  */

maxdist=25;
fn lnmaxc(nhold)=ln(maxc((nhold')|ones(1,rows(nhold)))); /*this evaluates the ln at min n or one */
z_2000=ones(rows(n_2000),1)~lnmaxc(neig5_2000)~(lnmaxc(neig5_2000).^2)~pcitrun_2000~blackshr_2000~youngshr_2000~oldshr_2000;
z_1990=ones(rows(n_1990),1)~lnmaxc(neig5_1990)~(lnmaxc(neig5_1990).^2)~pcitrun_1990~blackshr_1990~youngshr_1990~oldshr_1990;
z_1980=ones(rows(n_1980),1)~lnmaxc(neig5_1980)~(lnmaxc(neig5_1980).^2)~pcitrun_1980~blackshr_1980~youngshr_1980~oldshr_1980;


// Now set parameters.

labor_requirement=3.6146;


//  The following values obtained from constrained_model2.out ;
// see C:\a_datprg\proj\wal_proj\demand3\model\constrained_plus_logit
let theta={
       37.27694265929148, 
       36.76438001309305,
      0.7031133132351890, 
    -0.05595170504494120, 
      -7.834190541206559, 
       1.861173102097382, 
    -0.05857749260854525, 
     0.01291499533722669, 
      0.2973311160425939, 
       1.131972161217882, 
      0.4600267385918790, 
      0.2069302955433436, 
     0.06512826378605127 
     };


print "Demand parameters are the constrained parameters (to hit cannibal=1) and logit";


lam_reg=theta[1];
lam_super=theta[2];
tau0=theta[3];
tau1=theta[4]; tau=0;  //In the paper this is xzi.
omega=theta[5:11];  // In paper this variable is alpha, noticed later the conflict with omega here and for the population density function.
gam=theta[12];


//------------------------------------------------------------------------------------------------------------------------------
/* Calculates demand for given decennial census  */
proc (3) =sal_calc_step1(store_exist,superdum,Ibig,first_store,last_store,store_neig,n,z,neig5,x);
local i, pwal, pstore_wal,store_neig_i_hold, store_neig_i, delta0, delta, top, bot, theta, neig_i_exist, 
sales_hat_fill_gen, sales_hat_fill_groc, sales_hat_fill;
pwal=zeros(Ibig,1);
@initialze sales, convenient to have filler set to zero@
sales_hat_fill_gen=zeros(max_storenum,1);
sales_hat_fill_groc=zeros(max_storenum,1);
i=1;
do while i<=Ibig;
    if first_store[i]>0;  /*check if have any stores within 30 miles  */
/* First calculate general store sales (including regular items at supercenters  */
        store_neig_i=store_neig[first_store[i]:last_store[i],.];  /*first col is storenum, second col is distance  */
        neig_i_exist=store_exist[store_neig_i[.,1]]; /* indicator for which stores exist  */
        if sumc(neig_i_exist)>0;
            store_neig_i=selif(store_neig_i,neig_i_exist);
            if minc(store_neig_i[.,2])<=maxdist;
                /* location level variables */
                tau=tau0+tau1*lnmaxc(neig5[i]);
                delta0=z[i,.]*omega;
                /* store level variables */
                store_neig_i=selif(store_neig_i,store_neig_i[.,2].<=maxdist);
                delta=-tau.*store_neig_i[.,2] + x[store_neig_i[.,1],.]*gam;
                top=sumc(exp(delta));
                bot=exp(delta0) + top;
                pwal[i]=top/bot;
                pstore_wal=exp(delta)./sumc(exp(delta));
                sales_hat_fill_gen[store_neig_i[.,1]]=sales_hat_fill_gen[store_neig_i[.,1]]+(lam_reg*n[i]*pwal[i]).*pstore_wal;
            endif;            
        endif;
/* Next calculate supercenter sales */
        store_neig_i=store_neig[first_store[i]:last_store[i],.];  /*first col is storenum, second col is distance  */
        neig_i_exist=superdum[store_neig_i[.,1]]; /* indicator for which supercenters exist  */
        if sumc(neig_i_exist)>0;
            store_neig_i=selif(store_neig_i,neig_i_exist);
            if minc(store_neig_i[.,2])<=maxdist;
                /* location level variables */
                tau=tau0+tau1*lnmaxc(neig5[i]);
                delta0=z[i,.]*omega;
                /* store level variables */
                store_neig_i=selif(store_neig_i,store_neig_i[.,2].<=maxdist);
                delta=-tau.*store_neig_i[.,2] + x[store_neig_i[.,1],.]*gam;
                top=sumc(exp(delta));
                bot=exp(delta0) + top;
                pwal[i]=top/bot;
                pstore_wal=exp(delta)./sumc(exp(delta));
                sales_hat_fill_groc[store_neig_i[.,1]]=sales_hat_fill_groc[store_neig_i[.,1]]+(lam_super*n[i]*pwal[i]).*pstore_wal;
            endif;            
        endif;

    endif;
i=i+1; endo;
sales_hat_fill=sales_hat_fill_gen+sales_hat_fill_groc;
retp(sales_hat_fill,sales_hat_fill_gen,sales_hat_fill_groc);
endp;

proc (3) =sal_calc_step2(store_exist,superdum,date_evaluate,x);
local  sales_hat_fill, sales_hat_fill_gen, sales_hat_fill_groc,
sales_hat_fill_hold,sales_hat_fill_gen_hold,sales_hat_fill_groc_hold, w1980, w1990, w2000, 
n, first_store, last_store, store_neig, neig5, z, Ibig; //Modified on 6/6/2006: added "Ibig"
sales_hat_fill=zeros(max_storenum,1);
sales_hat_fill_gen=zeros(max_storenum,1);
sales_hat_fill_groc=zeros(max_storenum,1);

if date_evaluate<=1980;
    w1980=1; w1990=0; w2000=0;
elseif (date_evaluate>1980)and (date_evaluate<=1990);
    w1990=(date_evaluate-1980)/10; w1980=1-w1990; w2000=0;
elseif (date_evaluate>1990)and (date_evaluate<=2000);
    w2000=(date_evaluate-1990)/10; w1990=1-w2000; w1980=0;
else;
    w2000=1; w1990=0; w1980=0;
endif;
if w2000>0;
    Ibig=Ibig_2000;
    first_store=first_store_2000; last_store=last_store_2000;store_neig=store_neig_2000;neig5=neig5_2000; z=z_2000;n=n_2000;
    {sales_hat_fill_hold,sales_hat_fill_gen_hold,sales_hat_fill_groc_hold}=
    sal_calc_step1(store_exist,superdum,Ibig,first_store,last_store,store_neig,n,z,neig5,x);

    {sales_hat_fill_hold,sales_hat_fill_gen_hold,sales_hat_fill_groc_hold}=
    sal_calc_step1(store_exist,superdum,Ibig,first_store,last_store,store_neig,n,z,neig5,x);

    sales_hat_fill =sales_hat_fill + w2000.*sales_hat_fill_hold; /* Note weighting by w2000 */
    sales_hat_fill_gen =sales_hat_fill_gen + w2000.*sales_hat_fill_gen_hold; /* Note weighting by w2000 */
    sales_hat_fill_groc =sales_hat_fill_groc + w2000.*sales_hat_fill_groc_hold; /* Note weighting by w2000 */
endif;
if w1990>0;
    Ibig=Ibig_1990;
    first_store=first_store_1990; last_store=last_store_1990;store_neig=store_neig_1990;neig5=neig5_1990; z=z_1990;n=n_1990;
    {sales_hat_fill_hold,sales_hat_fill_gen_hold,sales_hat_fill_groc_hold}=
    sal_calc_step1(store_exist,superdum,Ibig,first_store,last_store,store_neig,n,z,neig5,x);
    sales_hat_fill = sales_hat_fill + w1990.*sales_hat_fill_hold; /* Note weighting by w1990 */
    sales_hat_fill_gen = sales_hat_fill_gen + w1990.*sales_hat_fill_gen_hold; /* Note weighting by w1990 */
    sales_hat_fill_groc = sales_hat_fill_groc +w1990.*sales_hat_fill_groc_hold; /* Note weighting by w1990 */
endif;
if w1980>0;
    Ibig=Ibig_1980;
    first_store=first_store_1980; last_store=last_store_1980;store_neig=store_neig_1980;neig5=neig5_1980; z=z_1980;n=n_1980;
    {sales_hat_fill_hold,sales_hat_fill_gen_hold,sales_hat_fill_groc_hold}=
    sal_calc_step1(store_exist,superdum,Ibig,first_store,last_store,store_neig,n,z,neig5,x);
    sales_hat_fill = sales_hat_fill + w1980.*sales_hat_fill_hold; /* Note weighting by w1980 */
    sales_hat_fill_gen = sales_hat_fill_gen + w1980.*sales_hat_fill_gen_hold; /* Note weighting by w1980 */
    sales_hat_fill_groc =sales_hat_fill_groc + w1980.*sales_hat_fill_groc_hold; /* Note weighting by w1980 */
endif;
retp(sales_hat_fill,sales_hat_fill_gen,sales_hat_fill_groc);
endp;


//------------------------------------------------------------------------------------------------------------------------------
/* The following procedure takes a year and outputs the weights for years 1980, 1990, and 2000. */

proc (3) = weight(date_evaluate);
local w1980, w1990, w2000;
    if date_evaluate<=1980;
        w1980=1; w1990=0; w2000=0;
    elseif (date_evaluate>1980)and (date_evaluate<=1990);
        w1990=(date_evaluate-1980)/10; w1980=1-w1990; w2000=0;
    elseif (date_evaluate>1990)and (date_evaluate<=2000);
        w2000=(date_evaluate-1990)/10; w1990=1-w2000; w1980=0;
    else;
        w2000=1; w1990=0; w1980=0;
    endif;
retp(w1980, w1990, w2000);
endp;

// Using weight(.), we can compute complex combs of neig5's, as below:

proc neig5(date_evaluate);
local w1980, w1990, w2000;
    {w1980, w1990, w2000}=weight(date_evaluate);
retp(w1980*neig5_1980_store+w1990*neig5_1990_store+w2000*neig5_2000_store);
endp;

// Define a function that takes the ln of max(input,1)
fn lnmaxc(nhold)=ln(maxc((nhold')|ones(1,rows(nhold)))); /*this evaluates the ln at min n or one */



//------------------------------------------------------------------------------------------------------------------------------
/* The following procedure takes a tsec from the past and shows how many minutes have lapsed since tsec, if change <24 hr. 
    This gets around the problem of what happens when a program runs overnight. */

proc time_change(tsec);
local hold;
    hold=((hsec-tsec)/100)/60;
    if hold<0;
        hold=24*60+hold;
    endif;
retp(hold);
endp;

//------------------------------------------------------------------------------------------------------------------------------

/* -----------------------------------------------------------------
** var_annual_calc - Calculate 12 variables for a given store configuration in particular year
** -----------------------------------------------------------------
** Input        store_exist: 5498*1 vector. ith =1 implies general merchansise store #i does exist.   
**              super_exist: 5498*1 vector. ith =1 implies super center #i does exist.
**              year_evaluate: scalar. Year we evaluate each output. 
**              x: 5498*1 vector. ith raw=1 implies regular store #i has been in operation for more than two years.  (for demand model)
**                 
** Output (all vars are scalars)
**              sal_gen: sales of general merchandise (total over all stores), in $million 2005 dollars
**            	sal_groc: sales of groceries  in $million 2005 dollars
**		        wage_gen: multiply labor_requirement=3.6146 to get annual wages, $million 2005 for general merchandise
**	        	wage_groc: multiply labor_requirement=3.6146 to get annual wages, $million 2005 for groceries
**              rent_gen   mulitply by .36118*(1/5) to get annual rent, $million 2005 for general merchansie
**              rent_groc  mulitply by .36118*(1/5) to get annual rent, $million 2005 for groceries
**		        lnneig5_gen: (corresponds to F1 in the paper for general merchansie)
**		        lnneig5_2_gen:(corresponds to F2 in the paper for general merchansie)
**		        lnneig5_groc: (corresponds to F1 in the paper for food (called grocery before)
**		        lnneig5_2_groc: (corresponds to F2 in the paper for food (called grocery before)
**		        dc_gen_dist: the sum of the distance from each regular stores to the closest regular distribution center.
**		        dc_groc_dist: the sum of the distance from each super centers to the closest grocery distribution center.
** -----------------------------------------------------------------*/

proc (12)=var_annual_calc(store_exist, super_exist, year_evaluate, x);
    local sales_fill,sales_fill_gen,sales_fill_groc, sal_gen, sal_groc, wage_gen, wage_groc, rent_gen, rent_groc, hold, 
lnneig5_gen, lnneig5_2_gen, lnneig5_groc, lnneig5_2_groc, 
dc_gen_dist, dc_groc_dist, RegDC_exist, FoodDC_exist;

    // First calculate sales.
    {sales_fill,sales_fill_gen,sales_fill_groc} = sal_calc_step2(store_exist,super_exist,year_evaluate,x);
    sales_fill_gen=(52/1000).*sales_fill_gen;  //convert from $1,000 per week to $1,000,000 per year.  $1000 per week are the original units in TradeDimensions
    sales_fill_groc=(52/1000).*sales_fill_groc;  //convert from $1,000 per week to $1,000,000 per year. $1000 per week are the original units in TradeDimensions

    sal_gen=sumc(sales_fill_gen);  //total gen sales across all stores.
    sal_groc=sumc(sales_fill_groc); //total groc sales across all stores.
    
    // Next caculate wage variable.
    wage_gen=sumc(sales_fill_gen.*wage_store_year[.,year_evaluate-1961])./1000;
    wage_groc=sumc(sales_fill_groc.*wage_store_year[.,year_evaluate-1961])./1000;
    
    // Next caculate rent variable.
    rent_gen=sumc(sales_fill_gen.*rent_index_store_year[.,year_evaluate-1961])./1000;
    rent_groc=sumc(sales_fill_groc.*rent_index_store_year[.,year_evaluate-1961])./1000;

    // Next calculate lnneig5 and lnneig5_2
    hold=lnmaxc(neig5(year_evaluate));
    lnneig5_gen=sumc(store_exist.*hold);
    lnneig5_2_gen = sumc(store_exist.*hold.^2);
    lnneig5_groc=sumc(super_exist.*hold);
    lnneig5_2_groc=sumc(super_exist.*hold.^2);

    
    // Next calculate distance to distribution centers 
    RegDC_exist=(year_RegDC-1).<=year_evaluate;
    FoodDC_exist=(year_FoodDC-1).<=year_evaluate;

        // Calculate Distance between regular stores and the closest RegDC
    if sumc(RegDC_exist)>0;
        dc_gen_dist=sumc(selif(minc((selif(RegDC_distmat,RegDC_exist))), store_exist));
    else;
        dc_gen_dist=0; @if no RegDC exists, set zero. @
    endif;
    
        // Calculate Distance between super stores and the closest FoodDC
    if sumc(FoodDC_exist)>0;
        dc_groc_dist=sumc(selif(minc((selif(FoodDC_distmat,FoodDC_exist))), super_exist));
    else;
        dc_groc_dist=0;   @if no FoodDC exists, set zero. @
    endif;
    

    retp(sal_gen, sal_groc, wage_gen, wage_groc, rent_gen, rent_groc, lnneig5_gen, lnneig5_2_gen, lnneig5_groc, lnneig5_2_groc, 
         dc_gen_dist, dc_groc_dist);
endp;


